
#    Note:  This is loaded into the namespace  ASIC4

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable ASICList {1 2 3 4}
    variable ASIC [first $ASICList]

    variable allmodules 0
    variable allasics 0
    variable autobias 1

	foreach asic $ASICList {
	    for {set i 0} {$i < 28} {incr i} {
		variable Opts.$asic.Value$i 0
		variable Opts.$asic.Offset$i $i
	    }
	}

    variable         Opts.Title8  "low_ref (pre-amp polarity)"
    variable         Opts.Title9  "shaping time"
    variable         Opts.Title10  "medium/low energy selection"

    variable         Opts.Title12  "slow comparator threshold"

    variable         Opts.Title14  "fast comparator threshold HEC"
    variable         Opts.Title15  "fast comparator threshold LEC/MEC"
 

   proc  show_variables {} {
       variable allmodules 
       variable allasics
       variable ASIC

       InsertLog "FEE64 = $::AIDA::FEE64; ASIC = $ASIC"
       InsertLog "all modules = $allmodules; all asics = $allasics"
   }

   proc do_redisplay {} {

     variable ASICList
	foreach asic $ASICList {
	     for {set i 0} {$i < 27} {incr i} {
	       variable Opts.$asic.Value$i
	       set Opts.$asic.Value$i [ReadAIDARegister [expr 0x4000 + (($asic-1)*64) + $i]]
	     }
	}
   }

   proc do_setOpt { j i vl} {
      variable ASIC
      variable ASICList
      variable allasics
      variable allmodules
      variable autobias
  
	set ASIC $j
  	set PolList { Positive Negative }
  	set EngList { 20MeV 1GeV }
	set ShapeList { 0.5uS 1uS 1.5uS 2uS 2.5uS 3uS 3.5uS 4uS 4.5uS 5uS 5.5uS 6uS 6.5uS 7uS 7.5uS 8uS }
	set HoldList { 1 1 1 2 2 2 2 3 3 3 3 4 4 4 4 5 } 
      set BAK $::AIDA::FEE64
	switch $i { 
		8 { set vl [ lsearch $PolList $vl ] }
		9 { set vl [ lsearch $ShapeList $vl ] }
		10 { set vl [ lsearch $EngList $vl ] }
		default { set vl $vl }
	}

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

  	foreach asic $ASICList {
              if {$allasics == 0 && $asic != $ASIC} continue
              WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + $i] $vl
		if { $i == 9 } {
			set new_hold [ lindex $HoldList $vl ]
      			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 7] $new_hold
		}
		if { $i == 8  } {
			if { $vl ==  0 } { 
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 11] 2
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 13] 0xdb
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 18] 0x30
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 21] 0x0b
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 26] 0x11
			} else {
             			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 11] 0x0d
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 13] 0x34
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 18] 0xb2
              			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 21] 0x08
             			WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 26] 0xca
			}
		}		
          }
      }

      set ::AIDA::FEE64 $BAK

      LoadASIC
   }

   proc ShowTemps {} {
      variable allmodules

      set BAK $::AIDA::FEE64

      set m ""

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          WriteAIDARegister 0x200 0          ;#    initiate Virtex temp measurement
          set vl0 [ReadAIDARegister 0x201]   ;#  get it

          WriteAIDARegister 0x202 0          ;#    initiate PSU temp measurement
          set vl1 [ReadAIDARegister 0x203]   ;#  get it

          WriteAIDARegister 0x204 0          ;#    initiate ASIC temp measurement
          set vl2 [ReadAIDARegister 0x205]   ;#  get it

          append m "$::AIDA::FEE64\n\
                      Virtex Temp = [expr $vl0 * 0.0625]C ([format "0x%04x" $vl0])\n\
                      PSU Temp = [expr $vl1 * 0.0625]C ([format "0x%04x" $vl1])\n\
                      ASIC Temp = [expr $vl2 * 0.0625]C ([format "0x%04x" $vl2])\n"
      }

      set ::AIDA::FEE64 $BAK
     
      Alert $m

     return $m

   }

   proc LoadASIC  {} {
      variable ASIC
      variable ASICList
      variable allasics
      variable allmodules

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
 
          foreach asic $ASICList {
             if {$allasics == 0 && $asic != $ASIC} continue
             WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers
          }
      }
      set ::AIDA::FEE64 $BAK
   }

   proc CheckASIC {} {
       variable ASIC
       variable ASICList
       variable allasics
      variable allmodules

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

      foreach asic $ASICList {
         if {$allasics == 0 && $asic != $ASIC} continue

         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers twice
         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0  

         for {set i 0} {$i < 5} {incr i} {
            set addr [expr 0x4000 + (($asic-1)*64) + $i + 32]
            set C$i [ReadAIDARegister $addr]
         }

         for {set i 0} {$i < 5} {incr i} {
            set addr [expr 0x4000 + (($asic-1)*64) + $i + 40]
            set R$i [ReadAIDARegister $addr]
         }

#    now perform check

         for {set i 0} {$i < 5} {incr i} {
             if {[set C$i] != [set R$i]} {
                Alert "ASIC load check failed\n\
                   TxR [format 0x%08x $C0] [format 0x%08x $C1] [format 0x%08x $C2]\
                        [format 0x%08x $C3] [format 0x%08x $C4]\n\
                   RxR [format 0x%08x $R0] [format 0x%08x $R1] [format 0x%08x $R2]\
                        [format 0x%08x $C3] [format 0x%08x $R4]\n"
                return
             }
         }

         InsertLog "$::AIDA::FEE64: ASIC $asic load check OK"
      }
      }
      set ::AIDA::FEE64 $BAK
   }

   proc DEFAULT {} {
       variable ASIC
       variable ASICList
       variable allasics
      variable allmodules

      set BAK ::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          foreach asic $ASICList {
             if {$allasics == 0 && $asic != $ASIC} continue
             WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 30] 0
          }
      }
      set ::AIDA::FEE64 $BAK

      LoadASIC
   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   ASIC     {variable ASIC; set ASIC $vl}
                   ALLASICS {variable allasics; set allasics [expr ($allasics + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

     do_redisplay

}   ;# end of if {$started == 0}




