
#    Note:  This is loaded into the namespace  TSCAN

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0
    
    variable temperatures ""

    variable OptTmaxVirtex 65
    variable OptTmaxPSU 35
    variable OptTmaxASIC 55

	foreach item $::AIDA::ModuleMenu {
#		InsertLog "Doing create for $item"
    		variable Opt900$item "___ No response"
     		variable Opt901$item "___ No response"
     		variable Opt902$item "___ No response"
     		variable Opt903$item "___ No response"
    		variable Opt904$item "___ No response" 
	}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }

   proc do_redisplay {} {
# modify for the table showing different values for each FEE64
     variable temperatures
     variable allmodules 



      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
     		variable Opt900$fee64
     		variable Opt901$fee64 
     		variable Opt902$fee64 
		variable Opt903$fee64 
		variable Opt904$fee64

	        set ::AIDA::FEE64 $fee64

	 	set Opt900$fee64 $fee64
           set rc1 [catch {exec ping -c 1 $fee64} m1]
	   if { $rc1 == 0 } {
		do_ShowTemps


		set Opt901$fee64 [ lindex $temperatures 0 ]
		set Opt902$fee64 [ lindex $temperatures 1 ]
		set Opt903$fee64 [ lindex $temperatures 2 ]
	
	        set Opt904$fee64 [ReadAIDARegister 14 ] 
		} else {
			
		set Opt901$fee64 "___ No response"
		set Opt902$fee64 "___ No response"
		set Opt903$fee64 "___ No response"
	
	        set Opt904$fee64 "No response" 
		}
#	InsertLog  "$Opt900 $Opt901 $Opt904"
#      }

      set ::AIDA::FEE64 $BAK   ;#   restore


   }
   proc do_ShowTemps {} {
	variable temperatures
    	variable OptTmaxVirtex 
    	variable OptTmaxPSU 
    	variable OptTmaxASIC 

      if {![info exists ::ASIC::started]} {
          InsertLog "You must start ASIC Control Window first"
          return
      }
	  WriteAIDARegister 0x200 0          ;#    initiate Virtex temp measurement
	  set vl0 [ReadAIDARegister 0x201]   ;#  get it

	  WriteAIDARegister 0x202 0          ;#    initiate PSU temp measurement
	  set vl1 [ReadAIDARegister 0x203]   ;#  get it

	  WriteAIDARegister 0x204 0          ;#    initiate ASIC temp measurement
	  set vl2 [ReadAIDARegister 0x205]   ;#  get it
	  set m ""
	  set vl0 [ expr $vl0 * 0.0625 ]
	  set vlt0 [format "%2.2f" $vl0]
	if { $vl0 <= $OptTmaxVirtex } {
		lappend m "<font color=green>$vlt0<\/font>"
	} else {
		lappend m "<font color=red>$vlt0<\/font>"
	}
	  set vl1 [ expr $vl1 * 0.0625 ]
	  set vlt1 [format "%2.2f" $vl1]
	if { $vl1 <= $OptTmaxPSU } {
		lappend m "<font color=green>$vlt1<\/font>"
	} else {
		lappend m "<font color=red>$vlt1<\/font>"
	}
	  set vl2 [ expr $vl2 * 0.0625 ]
	  set vlt2 [format "%2.2f" $vl2]
	if { $vl2 <= $OptTmaxASIC } {
		lappend m "<font color=green>$vlt2<\/font>"
	} else {
		lappend m "<font color=red>$vlt2<\/font>"
	}


      set temperatures $m
   }
   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x90a] 0x0
          WriteAIDARegister [expr 0x90a] 0x1    ;#  force waveform capture 
          WriteAIDARegister [expr 0x90a] 0x0
      }

      set ::AIDA::FEE64 $BAK   ;#  restore

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




